/******************************************************************
 * advert.c
 *
 * A simply little file just to draw the advertisement
 *
 */

#include "allegro.h"
#include "data.h"
#include "main.h"
#include "advert.h"

void advertisement()
{
	/* ok, i'm advertising allegro 4.0,.. with particles. */
	BITMAP *bmp_advert;
	BITMAP *bmp_buffer;	
	STAR stars[250];
	UINT8 i;
	
	/* initialize the stars */
	for (i=0; i!=250; i++)
	{
		stars[i].x = 320 + (rand() % 20) - 10;
		stars[i].y = 240 + (rand() % 20) - 10;
		stars[i].x_dir = (float)((rand() % 400) / 100.0) - 2.0;
		stars[i].y_dir = (float)((rand() % 400) / 100.0) - 2.0;
		stars[i].size = (rand() % 10) / 100;
	}

	clear(screen);
	play_midi((MIDI*) data[MIDI_ADVERTISEMENT].dat,1);
	bmp_advert = (BITMAP *) data[BMP_ADVERTISEMENT].dat;  
	bmp_buffer = create_bitmap(640,480);	
	
	do 
	{
		clear(bmp_buffer);		

		/* update the star's movements */
		for (i=0; i!=250; i++)
		{
			stars[i].x += stars[i].x_dir;
			stars[i].y += stars[i].y_dir;
			if (stars[i].size < 1) stars[i].size += 0.005;
			if (stars[i].x > 640 || stars[i].y > 480 || stars[i].x < 0 || stars[i].y < 0 || stars[i].size > 1) 
			{
				/* time to reset this star - it must have moved off the edge */
				stars[i].x = 320 + (rand() % 20) - 10;
				stars[i].y = 240 + (rand() % 20) - 10;
				stars[i].x_dir = (float)((rand() % 400) / 100.0) - 2.0;
				stars[i].y_dir = (float)((rand() % 400) / 100.0) - 2.0;
				stars[i].size = .15;				
			}
			putpixel(bmp_buffer,stars[i].x,stars[i].y,makecol(255*stars[i].size,255*stars[i].size,255*stars[i].size));
		}				
		masked_blit(bmp_advert,bmp_buffer,0,0,0,0,640,480);				
		vsync(); /* vsync isn't needed, but it's just used as a cheap slow-down for fast computers */
		blit(bmp_buffer,screen,0,0,0,0,640,480);				
	} while (!keypressed());

	/* always clean up */
	stop_midi();
	destroy_bitmap(bmp_buffer);	
}
