/******************************************************************
 * animate.c
 *
 * Not actually used to it's full potential, but this should have
 * controlled all the on-screen "sprites". For now it just draws 
 * the "times X" tiles.
 *
 */

#include "allegro.h"

#include "data.h"
#include "main.h"
#include "animate.h"

ANIMATE *animations;
BITMAP *bmp_times[12];

void animate_add_times(INT8 value, INT16 x, INT16 y)
{
	/* a "times" is the little tile that floats up with chain number */
	ANIMATE *ani = malloc(sizeof(ANIMATE));

	/* any chain over 11 is represented by a ? mark */
	if (--value > 11) value = 1;

	/* set the relevent info */
	ani->next = animations;
	ani->bmp = bmp_times[value];
	ani->x = x;
	ani->y = y;
	ani->y_dir = 0;
	ani->x_dir = -1;
	ani->length = 32;

	animations = ani;
	
}

void animate_draw(BITMAP *bmp)
{
	/* draws all the animations in the list */
	ANIMATE *ani = animations;

	while (ani)
	{
		if (ani->x > 48)
			draw_sprite(bmp, ani->bmp, ani->y, ani->x);
		ani = ani->next;
	}
}

void animate_init()
{
	/* initialize all the animation stuff */
	BITMAP *temp;
	INT8 x;

	temp = (BITMAP *)data[BMP_TIMES].dat; 
	
	for (x=0; x!=12; x++)
	{
		bmp_times[x] = create_bitmap(32,32);
		blit(temp,bmp_times[x],x*32,0,0,0,32,32);
	}

	destroy_bitmap(temp);


	animations = NULL;
}

void animate_move()
{
	/* update the animation positions */
	ANIMATE **ani_parent = &animations;
	ANIMATE *ani = animations;
	ANIMATE *ani_temp;

	while (ani)
	{
		if (!ani->length--) 
		{
			*ani_parent = ani->next;
			ani_temp = ani;
			ani = ani->next;
			free(ani_temp);
		}
		else
		{			
			ani->y += ani->y_dir;
			ani->x += ani->x_dir;
			
			ani_parent = &ani->next;
			ani = ani->next;
		}
	}
}