/******************************************************************
 * chain.c
 *
 * This is probably the most confusing area of the code. A linked 
 * list is used to help keep track of the current destroying and
 * swapping blocks. This is so we don't have to loop through the
 * entire well table to check on the statuses.
 *
 */

#include "allegro.h"

#include "main.h"
#include "block.h"
#include "chain.h"

/* add a block to the most recent chain */
void chain_add_block(CHAIN *c, INT8 row, INT8 col)
{	
	BLOCK *tmp = malloc(sizeof(BLOCK));
	
	tmp->r = row;
	tmp->c = col;
	tmp->next = c->blocks;
	c->blocks = tmp;
}

/* create a new empty chain */
void chain_new(CHAIN **c, INT8 type)
{
	CHAIN *tmp = malloc(sizeof(CHAIN));

	tmp->type = type;
	tmp->blocks = NULL;
	if (type == C_DESTROY) tmp->grace = 120;
	else if (type == C_SWAP) tmp->grace = 1;
	tmp->next = *c;
	*c = tmp;
}
