#ifndef __CHAIN_H__
#define __CHAIN_H__


/* some defines to help with the status of the block */
#define S_NORMAL           0
#define S_SWAPPING         1
#define S_NEW_CHAIN        2
#define S_CHAIN            3
#define S_HOVERING         4
#define S_FALLING          5
#define S_WAITING          6


/* the type of chain */
#define C_DESTROY         1
#define C_SWAP            2

/* the CHAIN is a string of blocks */

typedef struct CHAIN
{
	struct BLOCK *blocks;  /* each chain has three or more blocks */
	INT8 grace;            /* number of ticks */
	INT8 type;             /* the type of chain */
	struct CHAIN *next;
} CHAIN;


void chain_add_block(CHAIN *c, INT8 row, INT8 col);
void chain_new(CHAIN **c, INT8 type);


#endif