/******************************************************************
 * hiscore.c
 *
 * Not much explaining need here. Uses Allegro packfiles to store
 * the hiscores in a plain text file.
 *
 */

#include <stdio.h>
#include <string.h>

#include "allegro.h"

#include "data.h"
#include "main.h"
#include "hiscore.h"

INT8 hiscore_available = 0;
char hiscore_table[10][20];
char hiscore_scores[10][20];

void hiscore_add(char *default_name, INT32 score)
{	
	INT8 i, pos = -1; 
	INT16 k;	
	char name[30];
	char temp[2] = "_";

	text_mode(-1);
	strcpy(name, default_name);

	/* check to see if the score even is good enough */
	for (i=0; i!=10 && pos == -1; i++)	
		if (score >= atoi(hiscore_scores[i])) pos = i;

	if (pos >= 0)
	{
		/* let's get the guy's real name */
		BITMAP *save_screen = create_bitmap(640,480);
		BITMAP *bmp_temp = create_bitmap(640,480);		
		
		if (save_screen && bmp_temp)
		{
			/* not enough memory? sorry, no high score for you... */
			blit(screen, save_screen, 0,0, 0,0, 640,480);
			blit(screen, bmp_temp, 0,0, 0,0, 640,480);
			set_trans_blender(0,0,0,192);
			drawing_mode(DRAW_MODE_TRANS,NULL,0,0);

			rectfill(bmp_temp,0,0,639,479,C_BLACK);
			hiscore_font_print(bmp_temp, (FONT*)data[FONT_STICK].dat, 320, 100, makecol(255,255,192), "New High Score!");
			hiscore_font_print(bmp_temp, (FONT*)data[FONT_DIGITAL].dat, 320, 200, C_WHITE, "Enter your Name:");
		
			blit(bmp_temp,screen, 0,0,0,0, 640,480);

			do {
				vsync();
				blit(bmp_temp,screen, 0,250,0,250, 640,50);
				hiscore_font_print(screen, (FONT*)data[FONT_DIGITAL].dat, 320, 250, makecol(0,192,0), name);
				clear_keybuf();
				k = readkey() & 0xff;
				if (strlen(name) < 18)
				{
					if ((k >= 'A' && k <= 'Z') || (k >= 'a' && k <= 'z') || k == 32) 
					{
						sprintf(temp, "%c",k);
						strcat(name, temp);
					}					
					else if (k == 8 && strlen(name))
					{
						name[strlen(name)-1] = 0;						
					}
				}				
			} while (!strlen(name) || k != 13); /* enter */

			blit(save_screen, screen, 0,0,0,0, 640,480);
			
			/* move every one down */
			for (i=9; i!=pos; i--)
			{
				strcpy(hiscore_table[i], hiscore_table[i-1]);
				strcpy(hiscore_scores[i], hiscore_scores[i-1]);
			}

			/* add the new score */
			strcpy(hiscore_table[pos], name);
			sprintf(hiscore_scores[i], "%i", score);

		}
		
		/* better clean up, just in case */
		
		if (save_screen) destroy_bitmap(save_screen);
		if (bmp_temp) destroy_bitmap(bmp_temp);

	}

}

void hiscore_draw()
{	
	BITMAP *save_screen = create_bitmap(640,480);
	BITMAP *bmp_temp = create_bitmap(640,480);		
	INT8 i;

	text_mode(-1);
		
	if (save_screen && bmp_temp)
	{
		/* once again, you gotta have the memory */
		blit(screen, save_screen, 0,0, 0,0, 640,480);
		blit(screen, bmp_temp, 0,0, 0,0, 640,480);

		set_trans_blender(0,0,0,192);
		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		rectfill(bmp_temp,0,0,639,479,C_BLACK);
		
		hiscore_font_print(bmp_temp, (FONT*)data[FONT_STICK].dat, 320, 16, makecol(255,255,192), "HIGH SCORES");
		for (i=0; i!=10; i++)
		{			
			hiscore_font_print(bmp_temp, (FONT*)data[FONT_DIGITAL].dat, 220, (INT16)(95+i*32), C_WHITE, hiscore_table[i]);
			hiscore_font_print(bmp_temp, (FONT*)data[FONT_DIGITAL].dat, 420, (INT16)(95+i*32), C_WHITE, hiscore_scores[i]);
		}		
		
		blit(bmp_temp,screen, 0,0,0,0, 640,480);
		clear_keybuf();
		readkey();

		blit(save_screen, screen, 0,0,0,0, 640,480);
	}

	/* won't need these anymore */
	if (save_screen) destroy_bitmap(save_screen);
	if (bmp_temp) destroy_bitmap(bmp_temp);

}

void hiscore_font_print(BITMAP *bmp, FONT *fnt, INT16 x, INT16 y, INT32 c, char *msg)
{
	textprintf(bmp, fnt, x-text_length(fnt,msg)/2+2,y+2, C_BLACK, msg);	
	textprintf(bmp, fnt, x-text_length(fnt,msg)/2,y, c, msg);
}


void hiscore_init()
{
	PACKFILE *pf;
	INT32 i;
	char score[20];
	
	/* check to see if the high score file exists, if not we'll create a blank one */
	if (!exists("scores"))	
	{	
		pf = pack_fopen("scores", "w");		

		if (pf) 
		{
			for (i=2000; i>1000; i-=100)
			{
				sprintf(score, "%i\n", 0);
				pack_fputs("Matthew Leverton\n",pf);
				pack_fputs(score, pf);
			}
			pack_fclose(pf);
			hiscore_available = 1;
		}
	}

	if (exists("scores"))
	{
		pf = pack_fopen("scores","r");

		if (pf)
		{
			for (i=0; i!=10; i++)
			{
				pack_fgets(hiscore_table[i],20,pf);
				pack_fgets(hiscore_scores[i],20,pf);
			}
			/* i don't know if the next line actually helps or not */
			if (pack_ferror(pf)) hiscore_available = 0;
			pack_fclose(pf);
		}
		else hiscore_available = 0;
	}
}

void hiscore_shutdown()
{
	PACKFILE *pf;
	INT8 i;

	pf =  pack_fopen("scores","w");

	if (pf)
	{
		for (i=0; i!=10; i++)
		{
			strcat(hiscore_table[i], "\n");
			strcat(hiscore_scores[i], "\n");
			pack_fputs(hiscore_table[i],pf);
			pack_fputs(hiscore_scores[i],pf);
		}
		
		pack_fclose(pf);
	}
}