/******************************************************************
 * player.c
 *
 * This is more messy than I had hoped, but due to the time limit,
 * I started just to hack things in... The player_update() function
 * contains the bulk of the actual game logic.
 *
 */

#include <malloc.h>
#include <math.h>
#include <stdio.h>

#include "allegro.h"

#include "data.h"
#include "main.h"
#include "player.h"
#include "chain.h"
#include "block.h"
#include "animate.h"
#include "hiscore.h"

PLAYER *players;
BYTE total_players;
BYTE last_key_press[256];

void player_add_scores(void)
{
	INT8 pi;
	char name[30];

	for (pi=0; pi!=total_players; pi++)
	{
		sprintf(name, "Player %i", pi+1);
		hiscore_add(name,players[pi].score);
	}
}

void player_draw(BITMAP *bmp, BITMAP *save)
{	
	INT8 mins, secs;
	char score[255];
	
	/* we need to preserve the blackground, so we'll re-blit that */
	blit(save, bmp, 64,14, 64,14, 100,24);
	text_mode(-1);
	textprintf(bmp, (FONT*)data[FONT_DIGITAL].dat, 64,12,C_WHITE,"%i",players[0].score);
	
	if (total_players == 2)
	{
		blit(save, bmp, 476,14, 476,14, 100,24);
		sprintf(score,"%i",players[1].score);
		textprintf(bmp, (FONT*)data[FONT_DIGITAL].dat, 576-text_length((FONT*)data[FONT_DIGITAL].dat,score),12,C_WHITE,"%i",players[1].score);
	}
	
	mins = clock_ticks / 3600;
	secs = (clock_ticks - mins * 3600) / 60;

	/* draw the time left */
	sprintf(score,"%i:%02i",mins,secs);
	blit(save, bmp, 290,130, 290,130, 60,25);
	textprintf(bmp, (FONT*)data[FONT_DIGITAL].dat, 320-text_length((FONT*)data[FONT_DIGITAL].dat,score)/2,130,C_WHITE,"%i:%02i",mins,secs);
		
}

void player_end_game_draw(BITMAP *bmp)
{	
	/* terrible end of game routine */
	FONT *font = (FONT*)data[FONT_STICK].dat;
	INT8 pi;

	set_trans_blender(0,0,0,192);
	drawing_mode(DRAW_MODE_TRANS,NULL,0,0);

	for (pi=0; pi!=total_players; pi++)
	{				
		rectfill(players[pi].well.bmp_well, 0,0, 192,384, C_BLACK);
	}

	text_mode(-1);

	if (total_players == 2)
	{
		if (players[0].score > players[1].score)
		{
			textprintf(players[0].well.bmp_well,font, 2+192/2 - text_length(font,"WIN!")/2, 2+384/2 - text_height(font)/2, C_BLACK, "WIN!");
			textprintf(players[1].well.bmp_well,font, 2+192/2 - text_length(font,"LOSE")/2, 2+384/2 - text_height(font)/2, C_BLACK, "LOSE");
			textprintf(players[0].well.bmp_well,font, 192/2 - text_length(font,"WIN!")/2, 384/2 - text_height(font)/2, C_WHITE, "WIN!");
			textprintf(players[1].well.bmp_well,font, 192/2 - text_length(font,"LOSE")/2, 384/2 - text_height(font)/2, C_WHITE, "LOSE");
		}
		else if (players[0].score < players[1].score)
		{
			textprintf(players[1].well.bmp_well,font, 2+192/2 - text_length(font,"WIN!")/2, 2+384/2 - text_height(font)/2, C_BLACK, "WIN!");
			textprintf(players[0].well.bmp_well,font, 2+192/2 - text_length(font,"LOSE")/2, 2+384/2 - text_height(font)/2, C_BLACK, "LOSE");
			textprintf(players[1].well.bmp_well,font, 192/2 - text_length(font,"WIN!")/2, 384/2 - text_height(font)/2, C_WHITE, "WIN!");
			textprintf(players[0].well.bmp_well,font, 192/2 - text_length(font,"LOSE")/2, 384/2 - text_height(font)/2, C_WHITE, "LOSE");
		}
		else
		{
			textprintf(players[0].well.bmp_well,font, 2+192/2 - text_length(font,"TIE!")/2, 2+384/2 - text_height(font)/2, C_BLACK, "TIE!");
			textprintf(players[1].well.bmp_well,font, 2+192/2 - text_length(font,"TIE!")/2, 2+384/2 - text_height(font)/2, C_BLACK, "TIE!");
			textprintf(players[0].well.bmp_well,font, 192/2 - text_length(font,"TIE!")/2, 384/2 - text_height(font)/2, C_WHITE, "TIE!");
			textprintf(players[1].well.bmp_well,font, 192/2 - text_length(font,"TIE!")/2, 384/2 - text_height(font)/2, C_WHITE, "TIE!");
		}
	}

	text_mode(0);
}

void player_init(BYTE total)
{	
	BYTE k=0;

	players = malloc(sizeof(PLAYER) * total);

	/* sorry for the crude approach, but the defaults will have to do! */
	if (total == 1)
	{
		players[0].keys[0] = KEY_UP;
		players[0].keys[1] = KEY_DOWN;
		players[0].keys[2] = KEY_LEFT;
		players[0].keys[3] = KEY_RIGHT;
		players[0].keys[4] = KEY_RSHIFT;
		players[0].keys[5] = KEY_RCONTROL;
		players[0].score = 0;
	}
	else if (total == 2)
	{
		players[0].keys[0] = KEY_W;
		players[0].keys[1] = KEY_S;
		players[0].keys[2] = KEY_A;
		players[0].keys[3] = KEY_D;
		players[0].keys[4] = KEY_LSHIFT;
		players[0].keys[5] = KEY_LCONTROL;
		players[0].score = 0;

		players[1].keys[0] = KEY_UP;
		players[1].keys[1] = KEY_DOWN;
		players[1].keys[2] = KEY_LEFT;
		players[1].keys[3] = KEY_RIGHT;
		players[1].keys[4] = KEY_RSHIFT;
		players[1].keys[5] = KEY_RCONTROL;
		players[1].score = 0;
	}

	/* initialize last key press table */
	do 	{
		last_key_press[k++] = 0;
	} while (k);

	/* initialize player */
	total_players = total;
	while (total--) 
	{
		players[total].is_dead = 0;
		well_init(&players[total].well);	
	}

	if (total_players == 2) draw_sprite_h_flip(players[0].well.bmp_backdrop, players[1].well.bmp_backdrop,0, 0);
}

BYTE player_key_press(BYTE k)
{
	BYTE kp = 0;

	if (key[k])
	{		
		if (!last_key_press[k]) kp = 1;
		last_key_press[k] = 1;
	}
	else
		last_key_press[k] = 0;

	return kp;
}

/* the way we're looping through the players is pathetic... 
 * in fact this whole function should be optimized and broken down into some chunks 
 */

INT8 player_move()
{
	BYTE r, c;
	BYTE consecutive = 0;   /* consecutive same-color blocks */
	PLAYER *p = players;
	BYTE pi = 0;
	BYTE chain_created;     /* set to 1 if a new chain has been created */
	BYTE someone_is_dead = 0; 
	
	for (pi=0; pi != total_players; pi++)
	{
		p = &players[pi];

		/* handle key presses */
		if (player_key_press(p->keys[2]) && p->well.sx) p->well.sx--;
		else if (player_key_press(p->keys[3]) && p->well.sx < COLS-2) p->well.sx++;
		else if (player_key_press(p->keys[0]) && p->well.sy) p->well.sy--;
		else if (player_key_press(p->keys[1]) && p->well.sy < ROWS-1) p->well.sy++;

		/* SEL_S1 & SEL_S2 are #defined in player.h  */
		if (player_key_press(p->keys[4]) && !SEL_S1 && !SEL_S2)
		{
			SEL_S1 = S_SWAPPING;
			SEL_S2 = S_SWAPPING;

			chain_new(&p->well.chains, C_SWAP);
			chain_add_block(p->well.chains, SEL_Y,SEL_X);
			p->well.scroll_wait = 1;
		
		}		


		/* scroll the well */
		if (!p->well.scroll_wait && p->well.scroll_speed && (!p->well.scroll_counter-- || key[p->keys[5]]))
		{
			p->well.skill_chains = 0;
			if (++p->well.scroll_offset == 32)
			{
				/* you get one point for scrolling the well yourself */
				if (key[p->keys[5]]) p->score++;

				/* move well up one position */
				for (c=0; c!=COLS; c++)
					for (r=0;r!=ROWS;r++)
						p->well.block[r][c] = p->well.block[r+1][c];

				/* add random line */
				for (c=0; c!=COLS; c++)
				{
					BYTE b = (rand() % 5) + 1;

					/* we've got to make sure that no 3 consecutive blocks (horizontal or vertical) are the same */
					while (c>1 && p->well.block[ROWS][c-1].tile == b && p->well.block[ROWS][c-2].tile == b)
						b = (rand() % 5) + 1;

					p->well.block[r][c].tile = b;
					p->well.block[r][c].status = S_NORMAL;
				}

				/* update variable */
				p->well.scroll_offset = 0;
				p->well.sy--;

				/* check to make sure the scolling can continue */
				for (c=0; c!=COLS; c++)
					if (p->well.block[0][c].tile) 
					{
						p->is_dead = 1;					
						someone_is_dead = 1;
					}
			}
			p->well.scroll_speed = (60 - p->score / 10);
			if (p->well.scroll_speed < 5) p->well.scroll_speed = 5;
			p->well.scroll_counter = p->well.scroll_speed;
		}


		/* drop blocks */
		for (c=0; c!=COLS; c++)
		{
			for (r=ROWS-1; r!=255; r--)
			{
				if (p->well.block[r][c].tile) 
				{
					/* count down if the block is hovering */
					if (p->well.block[r][c].status == S_HOVERING)
					{						
						if (p->well.block[r][c].wait-- == 0)
							p->well.block[r][c].status = S_FALLING;
					}

					/* drop the block if it is falling */
					else if (p->well.block[r][c].status == S_FALLING)
					{						
						p->well.block[r][c].r_adjust += 16;
						if (p->well.block[r][c].r_adjust >= 31 )
						{			
							/* the key here is to make sure that the block is re-marked as falling if it needs to be */
							if (!p->well.block[r+2][c].tile && !p->well.block[r+2][c].status)
							{
								p->well.block[r+1][c].status = S_FALLING;
								p->well.block[r+2][c].status = S_WAITING;
							}
							else if(p->well.block[r+2][c].status == S_FALLING)
							{
								p->well.block[r+1][c].status = S_FALLING;
							}
							else
								p->well.block[r+1][c].status = S_NORMAL;
							p->well.block[r+1][c].tile = p->well.block[r][c].tile;
							p->well.block[r][c].tile = 0;
							p->well.block[r][c].status = S_NORMAL;
							p->well.block[r][c].r_adjust = 0;							
						}
						
					}
					
					/* check to see if it needs to fall */
					else if (p->well.block[r][c].status == S_NORMAL)
					{
						if (!p->well.block[r+1][c].tile && !p->well.block[r+1][c].status)
						{
							p->well.block[r][c].status = S_HOVERING;
							p->well.block[r][c].wait = 15;
							p->well.block[r+1][c].status = S_WAITING;
						}
						else if (p->well.block[r+1][c].status == S_FALLING || p->well.block[r+1][c].status == S_HOVERING)
						{
							p->well.block[r][c].status = S_HOVERING;
							p->well.block[r][c].wait = 15;
						}
					}					
				}
			}
		}


		/*
		 * NOTE: This is extremely unoptimized. There's no reason to check the entire well 60 times per 
		 * second for new chains. If no blocks were swapped, then the only possible chains are vertical ones
		 * at the bottom due to the possible scrolling up of a layer. If blocks were swapped, then only the
		 * surrounding area should be checked (from the inside-out). But the fail-safe route will do for now. :)
		 */

		chain_created = 0;

		/* check for new horizontal chains */		
		for (r=0; r!=ROWS; r++) 
		{
			consecutive = 0;
			for (c=1; c!=COLS+1; c++)
			{
				if (c<COLS &&  p->well.block[r][c].tile && p->well.block[r][c].tile == p->well.block[r][c-1].tile && !p->well.block[r][c].status && !p->well.block[r][c-1].status )
					consecutive++;
				else 
				{
					if (consecutive > 1) 
					{	
						chain_created = 1;
						p->well.block[r][c-1].status = S_NEW_CHAIN;
						while (consecutive)	
						{
							p->well.block[r][c-consecutive-1].status = S_NEW_CHAIN;
							consecutive--;
						}
					}
					consecutive = 0;
				}
			}
		}

		/* check for new vertical chains */		
		for (c=0; c!=COLS; c++)		
		{
			consecutive = 0;
			for (r=1; r!=ROWS+1; r++) 
			{
				if (r<ROWS && !p->well.block[r][c].status && p->well.block[r][c].tile && p->well.block[r][c].tile == p->well.block[r-1][c].tile && !p->well.block[r-1][c].status)
					consecutive++;
				else 
				{
					if (consecutive > 1) 
					{	
						chain_created = 1;
						p->well.block[r-1][c].status = S_NEW_CHAIN;
						while (consecutive)	
						{
							p->well.block[r-consecutive-1][c].status = S_NEW_CHAIN;
							consecutive--;
						}
					}
					consecutive = 0;
				}
			}
		}


		/* create new chains (ie, mark blocks to be destroyed) */
		if (chain_created)
		{
			play_sample((SAMPLE*)data[WAV_POOF].dat,255,pi*255,2000,0);
			chain_new(&p->well.chains, C_DESTROY);
			p->score += (pow(2,p->well.skill_chains) * 10);
			p->well.skill_chains++;			
			for (r=0; r!=ROWS; r++)
				for (c=0; c!=COLS; c++)					
					if (p->well.block[r][c].status == S_NEW_CHAIN)
					{
						if (chain_created) 
						{
							animate_add_times(p->well.skill_chains, (INT16)((r-1)*32+p->well.dy), (INT16)(c*32+p->well.dx));
							chain_created = 0;
						}
						p->well.block[r][c].status = S_CHAIN;
						chain_add_block(p->well.chains, r,c);
						
					}

			p->well.scroll_wait = 1;			
		}

		/* loop through chains */
		{
			CHAIN **parent = &p->well.chains;
			CHAIN *chain = p->well.chains;
			CHAIN *temp_chain;
			INT8 del = 0;
			
			while (chain)
			{
				del = 0;

				chain->grace -= 2;
				if (chain->grace <= 0)
				{
					BLOCK *block = chain->blocks;
					
					if (chain->type == C_DESTROY)
					{	
						while (block)
						{											
							p->well.block[block->r][block->c].tile = 0;
							p->well.block[block->r][block->c].status = 0;
							block = block->next;
						}
						del = 1;
					}
					else if (chain->type == C_SWAP)
					{		
						WELL_BLOCK *wb1 = &p->well.block[block->r][block->c], *wb2 = &p->well.block[block->r][block->c+1];
						wb1->c_adjust+=8;
						wb2->c_adjust-=8;
						chain->grace = 1;

						if (wb1->c_adjust >= 30)
						{
							INT8 temp;
							wb1->status = S_NORMAL; 
							wb2->status = S_NORMAL;

							temp = wb1->tile;
							wb1->tile = wb2->tile;
							wb2->tile = temp;

							wb1->c_adjust = 0;
							wb2->c_adjust = 0;

							del = 1;
						}
					}					
				}

				if (del)
				{
					/* free all the blocks */
					BLOCK *block = chain->blocks;
					BLOCK *temp;
					while (block)
					{
						temp = block;
						block = block->next;
						free(temp);
					}

					/* delete chain from list & update parent as necessary */
					*parent = chain->next;
					temp_chain = chain;
					chain = chain->next;
					free(temp_chain);					
				}
				else
				{
					/* advance to next chain */
					parent = &chain->next;
					chain = chain->next;
				}				
			}

			if (p->well.chains == NULL) p->well.scroll_wait = 0;
		}

		if (p->is_dead) p->score = 0;
	}
	return someone_is_dead; 
}

void player_shutdown()
{
	BYTE i;

	/* shutdown the wells */
	for (i=0; i!=total_players; i++)
		well_shutdown(&players[i].well);

	free(players);
}

void player_well_draw(BITMAP *bmp)
{	
	BYTE p = total_players;

	while (p--)
		well_draw(&players[p].well); 
}

void player_well_pos(BYTE p, BITMAP *bmp, INT16 x, INT16 y)
{	
	players[p].well.bmp_well = create_sub_bitmap(bmp, x,y, 192,384);
	players[p].well.dx = x;
	players[p].well.dy = y;
}
