#ifndef __PLAYER_H__
#define __PLAYER_H__

#include "well.h"

#define MAX_PLAYERS 2    /* total number of players possible */

/* macros to simplify choosing the currently selected block */
#define SEL_X    (p->well.sx)
#define SEL_Y    (p->well.sy)
#define SEL_B1   (p->well.block[SEL_Y][SEL_X].tile)
#define SEL_B2   (p->well.block[SEL_Y][SEL_X+1].tile)
#define SEL_S1   (p->well.block[SEL_Y][SEL_X].status)
#define SEL_S2   (p->well.block[SEL_Y][SEL_X+1].status)


typedef struct PLAYER
{
	WELL well;       /* contains most of the data */
	BYTE keys[6];    /* handles key presses */
	INT32 score;     /* lets leave room for a big score */
	BYTE is_dead;    /* boolean yes means player is dead */
} PLAYER;

extern BYTE total_players;

void player_add_scores(void);
void player_draw(BITMAP *bmp, BITMAP *save);
void player_end_game_draw(BITMAP *bmp);
void player_init(BYTE total);
BYTE player_key_press(BYTE k);
INT8 player_move(void);
void player_shutdown(void);
void player_well_draw(BITMAP *bmp);
void player_well_pos(BYTE p, BITMAP *bmp, INT16 x, INT16 y);

#endif