#ifndef __WELL_H__
#define __WELL_H__

#define ROWS (12)             /* number of rows in the well */
#define COLS (6)              /* number of columns in the well */


/* WELL_BLOCK stores the actual data */
typedef struct WELL_BLOCK
{
	INT8 tile;
	INT8 status;
	INT8 r_adjust, c_adjust;
	INT8 wait;	
} WELL_BLOCK;

typedef struct WELL
{
	WELL_BLOCK block[ROWS+1][COLS];
	BITMAP *bmp_backdrop;     /* 192x384 */
	BITMAP *bmp_well;         /* 192x384 sub-bitmap */	
	BITMAP *bmp_selector[2];  /* the 76x44 selector icon with two frames of animation (offset by 6 pixels) */	
	INT16 dx, dy;             /* top left drawing coordinate of the well */
	INT8 sx, sy;			  /* x,y coordinates of the selector */
	INT16 scroll_wait;         /* if true then scrolling is paused */
	INT8 scroll_offset;       /* tracks the "scrolling up" effect; range from 0-31 */
	INT16 scroll_speed;       /* how many timer ticks per pixel scroll (y_offset++) */
	UINT8 scroll_counter;     /* begins at scroll_speed and decreases towards zero */
	INT8 skill_chains;        /* the number of chains that have been destroyed */

	struct CHAIN *chains;
	struct SWAP *swaps;
} WELL;

void well_draw(WELL *w);
void well_init(WELL *w);
void well_shutdown(WELL *w);

#endif